#ifndef _THIS_IS_GIDX_STR_WR
#error "dont include internal headers"
#endif

#ifndef _GIDX_STR_WR_H
#define _GIDX_STR_WR_H

#include <rbtree.h>
#include <gidx-str-format.h>

struct str_val {
	struct rb_node 		n_rbt;
	struct ro_vec		n_str;
	gidx_pkey_t		n_num_pkey;
	hgang_t			n_pkeys;
};

struct str_wr_priv {
	struct rbtree		p_vals;
	gidx_pkey_t		p_num_vals;
	hgang_t			p_nodes;
	gang_t			p_strtab;
	gidx_mode_t		p_mode;
	uint8_t			p_format;
	uint8_t			p_prepped;
	void			*p_fpriv;
};

_private int _str_radix_prep(struct str_wr_priv *strp);
_private uint16_t _str_radix_num_chunks(struct str_wr_priv *strp);
_private off_t _str_radix_chunk_size(struct str_wr_priv *strp,
					unsigned int chunk_id);
_private int _str_radix_chunk(struct str_wr_priv *strp,
				unsigned int chunk_id,
				fobuf_t buf);
_private void _str_radix_free(struct str_wr_priv *strp);

struct radix_hdr {
	gidx_pkey_t	h_num_vals;
};

#endif /* _GIDX_STR_WR_H */
