#ifndef _THIS_IS_LIBGIDX_WR
#error "dont include internal headers"
#endif

#include <fobuf.h>
#include <hgang.h>

#ifndef _GIDX_WR_CORE_H
#define _GIDX_WR_CORE_H

typedef struct _pkey_ctx *pkey_ctx_t;

struct _gidx_type_wr {
	const char *t_name;
	void *(*t_wr_init)(gidx_mode_t, unsigned int flags);
	int (*t_wr_insert)(void *priv, gidx_pkey_t pkey_id,
				void *record, void *field,
				union schema_get_val get_val);
	int (*t_wr_prep)(void *priv, uint8_t *format);
	uint16_t (*t_wr_num_chunks)(void *priv);
	uint8_t (*t_wr_chunk_format)(void *priv, unsigned int chunk_id);
	off_t (*t_wr_chunk_size)(void *priv, unsigned int chunk_id);
	int (*t_wr_chunk)(void *priv, unsigned int blkid, fobuf_t buf);
	gidx_pkey_t (*t_wr_num_vals)(void *priv);
	int (*t_wr_pkey_tbl)(void *priv, pkey_ctx_t pk);
	int (*t_wr_pkey_blks)(void *priv, pkey_ctx_t pk);
	void (*t_wr_fini)(void *priv);
};

_private extern struct _gidx_type_wr _gidx_str_type;
_private extern struct _gidx_type_wr _gidx_u32_type;
_private extern struct _gidx_type_wr _gidx_u16_type;
_private extern struct _gidx_type_wr _gidx_u8_type;
_private extern struct _gidx_type_wr _gidx_interval_type;
_private extern struct _gidx_type_wr *_gidx_types[GIDX_NR_TYPES];

_private int gidx_wr_align(fobuf_t buf, size_t obj_sz);

_private int pkey_tbl_entry(pkey_ctx_t ctx, gidx_pkey_t num_pkey);
_private int pkey_keyblock(pkey_ctx_t ctx, hgang_t pkeys);

#endif /* _GIDX_WR_CORE_H */
