#include <gidx.h>

int gidx_pkey_cmp(const void *A, const void *B)
{
	return *(gidx_pkey_t *)A - *(gidx_pkey_t *)B;
}

const char * const gidx_type_str(gidx_type_t type)
{
	switch(type) {
	case GIDX_TYPE_STRING:
		return "varchar";
	case GIDX_TYPE_U8:
		return "uint8_t";
	case GIDX_TYPE_U16:
		return "uint16_t";
	case GIDX_TYPE_U32:
		return "uint32_t";
	case GIDX_TYPE_U64:
		return "uint64_t";
	default:
		return "INVALID";
	}
}

const char * const gidx_mode_str(gidx_mode_t mode)
{
	switch(mode) {
	case GIDX_PRIMARY_KEY:
		return "PRIMARY";
	case GIDX_SECONDARY_KEY:
		return "SECONDARY";
	default:
		return "INVALID";
	}
}
