#include <gidx.h>
#include <unistd.h>
#include <gidx-rd.h>

int main(int argc, char **argv)
{
	gidx_rd_t rd;
	gidx_idx_t i_pkey, i_stringy;
	gidx_u32_t pkey;
	gidx_str_t stringy;

	rd = gidx_rd_open(STDIN_FILENO);
	if ( NULL == rd )
		return EXIT_FAILURE;

	mesg(M_INFO, "Opened database");

	i_pkey = gidx_rd_index(rd, "pkey");
	if ( i_pkey )
		mesg(M_INFO, "got index: pkey");

	i_stringy = gidx_rd_index(rd, "stringy");
	if ( i_stringy )
		mesg(M_INFO, "got index: stringy");

	pkey = gidx_u32_index(rd, i_pkey);
	if ( pkey )
		mesg(M_INFO, "ready to query pkey");

	stringy = gidx_str_index(rd, i_stringy);
	if ( pkey )
		mesg(M_INFO, "ready to query stringy");

	gidx_rd_fini(rd);
	return EXIT_SUCCESS;
}
