/*
* This file is part of blackbloc
* Copyright (c) 2010 Gianni Tedesco
* Released under the terms of the GNU GPL version 3
*/
#ifndef _GIDX_RD_H
#define _GIDX_RD_H

typedef struct _gidx_rd 	*gidx_rd_t;
typedef const struct gidx_idx 	*gidx_idx_t;
typedef struct _gidx_rd_str	*gidx_str_t;
typedef struct _gidx_rd_u32	*gidx_u32_t;

_public _check_result gidx_rd_t gidx_rd_open(int fd);
_public _check_result gidx_idx_t gidx_rd_index(gidx_rd_t rd,
							const char *name);
_public _check_result gidx_str_t gidx_str_index(gidx_rd_t rd,
						gidx_idx_t idx);
_public void gidx_str_index_free(gidx_str_t str);
_public _check_result gidx_u32_t gidx_u32_index(gidx_rd_t rd,
						gidx_idx_t idx);
_public void gidx_u32_index_free(gidx_u32_t str);
_public void gidx_rd_fini(gidx_rd_t rd);

#endif /* _GIDX_RD_H */
